From a6688571bb25b7c864c7dd5fdc294e56f720557f Mon Sep 17 00:00:00 2001
From: Mateusz Bieniek <38975612+mateuszbieniek@users.noreply.github.com>
Date: Tue, 8 Jan 2019 09:15:16 +0100
Subject: [PATCH] EZP-29957: Two XML blocks in the same Class in a different
 Categories will break second Online Editor (#1411)

---
 .../design/standard/javascript/classes/dom/Selection.js    | 7 +++----
 extension/ezoe/design/standard/javascript/tiny_mce.js      | 2 +-
 .../ezoe/design/standard/javascript/tiny_mce_jquery.js     | 2 +-
 .../ezoe/design/standard/javascript/tiny_mce_jquery_src.js | 7 +++----
 .../ezoe/design/standard/javascript/tiny_mce_prototype.js  | 2 +-
 .../design/standard/javascript/tiny_mce_prototype_src.js   | 7 +++----
 extension/ezoe/design/standard/javascript/tiny_mce_src.js  | 7 +++----
 7 files changed, 15 insertions(+), 19 deletions(-)

diff --git a/extension/ezoe/design/standard/javascript/classes/dom/Selection.js b/extension/ezoe/design/standard/javascript/classes/dom/Selection.js
index c8bd7b29544..2c0935c4bd8 100644
--- a/extension/ezoe/design/standard/javascript/classes/dom/Selection.js
+++ b/extension/ezoe/design/standard/javascript/classes/dom/Selection.js
@@ -876,12 +876,11 @@
 
 					try {
 						s.removeAllRanges();
+						s.addRange(r);
 					} catch (ex) {
-						// IE9 might throw errors here don't know why
+						// IE might throw errors here if the editor is within a hidden container and selection is changed
 					}
-
-					s.addRange(r);
-
+					
 					// Forward is set to false and we have an extend function
 					if (forward === false && s.extend) {
 						s.collapse(r.endContainer, r.endOffset);
diff --git a/extension/ezoe/design/standard/javascript/tiny_mce_jquery_src.js b/extension/ezoe/design/standard/javascript/tiny_mce_jquery_src.js
index 6b9136d4355..22c8d68a9b4 100644
--- a/extension/ezoe/design/standard/javascript/tiny_mce_jquery_src.js
+++ b/extension/ezoe/design/standard/javascript/tiny_mce_jquery_src.js
@@ -8831,12 +8831,11 @@ tinymce.dom.TreeWalker = function(start_node, root_node) {
 
 					try {
 						s.removeAllRanges();
+						s.addRange(r);
 					} catch (ex) {
-						// IE9 might throw errors here don't know why
+						// IE might throw errors here if the editor is within a hidden container and selection is changed
 					}
-
-					s.addRange(r);
-
+					
 					// Forward is set to false and we have an extend function
 					if (forward === false && s.extend) {
 						s.collapse(r.endContainer, r.endOffset);
diff --git a/extension/ezoe/design/standard/javascript/tiny_mce_prototype_src.js b/extension/ezoe/design/standard/javascript/tiny_mce_prototype_src.js
index d718aae9f95..d9c3fb5dc56 100644
--- a/extension/ezoe/design/standard/javascript/tiny_mce_prototype_src.js
+++ b/extension/ezoe/design/standard/javascript/tiny_mce_prototype_src.js
@@ -10077,12 +10077,11 @@ window.tinymce.dom.Sizzle = Sizzle;
 
 					try {
 						s.removeAllRanges();
+						s.addRange(r);
 					} catch (ex) {
-						// IE9 might throw errors here don't know why
+						// IE might throw errors here if the editor is within a hidden container and selection is changed
 					}
-
-					s.addRange(r);
-
+					
 					// Forward is set to false and we have an extend function
 					if (forward === false && s.extend) {
 						s.collapse(r.endContainer, r.endOffset);
diff --git a/extension/ezoe/design/standard/javascript/tiny_mce_src.js b/extension/ezoe/design/standard/javascript/tiny_mce_src.js
index 1f098e1d787..a957559751a 100644
--- a/extension/ezoe/design/standard/javascript/tiny_mce_src.js
+++ b/extension/ezoe/design/standard/javascript/tiny_mce_src.js
@@ -10050,12 +10050,11 @@ window.tinymce.dom.Sizzle = Sizzle;
 
 					try {
 						s.removeAllRanges();
+						s.addRange(r);
 					} catch (ex) {
-						// IE9 might throw errors here don't know why
+						// IE might throw errors here if the editor is within a hidden container and selection is changed
 					}
-
-					s.addRange(r);
-
+					
 					// Forward is set to false and we have an extend function
 					if (forward === false && s.extend) {
 						s.collapse(r.endContainer, r.endOffset);
